﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace mutex
{
    class Program
    {
        // BST Global Inc. Tampa Florida.

        // SETUPBUILDER 7.1 function Detect Active Application does not seem to 
        // see a named mutex.




        // Using SetupBuilder we want to be able to detect if the program is running
        // and when it stops running. We should be able to detect a 32bit or 64bit 
        // process. 
        // 
        // Using the named mutex does not work in SetupBuilder 7.1.2680.0 
        // Tested with this compiled explicitly as 32bit and 64bit.

        // Setting the title of the console application does work for both 32bit
        // and 64bit programs.

        static int Main(string[] args)
        {
            // Save the existing console window title.
            string oldTitle = Console.Title;

            // Set the title as a flag for setup builder.
            Console.Title = "RUNNING-SR";

            // Set the exit code
            int exitcode = 0;

            // Initialize the mutex variable.
            System.Threading.Mutex m = null;
            try
            {
                Console.WriteLine("Mutex test running...");

                // Create the named mutex with our process as the owner.
                m = new System.Threading.Mutex(true, "RUNNING-SR");
                
                try
                {
                    // Attempt to read it back. This will fail if it was
                    // not created or we search for a different name.
                    System.Threading.Mutex.OpenExisting("RUNNING-SR");

                    Console.WriteLine("Named mutex is set.");
                }
                catch
                {
                    Console.WriteLine("Named mutex is NOT SET.");
                }

                // Pause to give the installer time to display the fact that we are running.
                System.Threading.Thread.Sleep(10 * 1000);
            }
            catch(Exception ex)
            {
                // oh crap. Something bad happend...
                exitcode = 1;
            }
            finally
            {
                // Release our mutex, to signal we are done.
                if (null != m)
                    m.ReleaseMutex();

                // Reset the title to signal we are done.
                Console.Title = oldTitle;
            }

            Console.WriteLine("Exit code {0}", exitcode);
            return exitcode;
        }
    } // end class

} // end namespace
